
Section 1
### |A\ߒ̃pXV~[V
## f̒`
mod.cp <- setPoisson(intensity = "lambda", # x
                     df = list("dnorm(z,mu,sigma)") # U̕z̊mx֐
)
## Tv_̒`
Terminal <- 50 # I[_
samp <- setSampling(Initial = 0, # _
                    Terminal = Terminal, # I[_
                    n = 100*Terminal # Tv_
)
## vf̒`
cp <- setYuima(model = mod.cp, # mf
               sampling = samp # TvO_
)
## V~[VƃTvpX̕`
set.seed(123)
param <- list(lambda = 1, mu = 0, sigma = 1) # p[^[̒l
# V~[V̎s
result <- simulate(cp, # vf
                   xinit = 0, # l
                   true.parameter = param # p[^[̒l
)
plot(result, col = "royalblue", ylab = "S_t")





###  |A\ߒ̎ӕz
## V~[^[̍쐬
simulateXT <- function(smod, x0, param){
  out <- simulate(smod, xinit = x0, true.parameter = param)
  XT <- tail(get.zoo.data(out)[[1]], n = 1) # Ō̊ϑlo
  return(XT)
}
## Tv_̒`(t=1ōl)
n <- 30 # I[_
samp <- setSampling(Initial = 0, # _
                    Terminal = n, # I[_
                    n = 10*n # Tv_
)
## vf̒`
cp <- setYuima(model = mod.cp, # mf
               sampling = samp # TvO_
)
## p[^[̐ݒ
x0 <- 0 # l
lambda <- 1 # x
mu <- 0 # U̕
sigma <- 1 # U̕W΍
param <- list(lambda = lambda, mu = mu, sigma = sigma)
## eJEV~[V̎s
set.seed(123) # V[ȟŒ
MC <- 1000 # V~[V
result <- replicate(MC, simulateXT(cp, x0, param)) # V~[V
## qXgO̕`
Sn1 <- (result - lambda * mu * n)/sqrt(n) # Wvʂ̌vZ
hist(Sn1, freq = FALSE, breaks = 20,
     xlab = expression(S[n](1)), 
     main = expression(paste("Histogram of ", S[n](1))))
## _z̏㏑
curve(dnorm(x, mu, sigma), add = TRUE, col="red")




### |A\ߒ̊gUߎ
## p[^[̐ݒ
x0 <- 0 # l
lambda <- 1 # x
mu <- 0 # U̕
sigma <- 1 # U̕W΍
param <- list(lambda = lambda, mu = mu, sigma = sigma)
## n𑝂₵ȂpXvbgĂ
set.seed(111) # V[ȟŒ
ns <- c(10, 50, 100, 500) # n
op <- par(mfrow = c(2,2)) # `̈2x2ɕ
for(n in ns){
  samp <- setSampling(Initial = 0, Terminal = n, n = 50*n)
  cp <- setYuima(model = mod.cp, sampling = samp)
  result <- simulate(cp, xinit = 0, true.parameter = param)
  plot(result, main = bquote(expression(n == .(n))))
}
par(op) # ݒZbg


Section 2
### f}[N̉΍ЕیN[f[^
library(evir)	# evirpbP[W̓ǂݍ
data(danish)	# f[^Zbg"danish"Ă
Year <- attr(danish, "times")	# "times"̗̃f[^o
plot(Year, danish, ylab = "Danish Fire Insurance Claims", type = "h")


### htg̈̕ႢɂjYpx̔r

#htgtuE^(DBM)̃pXEV~[^
simulateDBM <- function(Time,@x,@c,@sigma){
	dt <- diff(Time)
	Zt <- rnorm(length(dt),@c*dt, sigma*sqrt(dt))
	DBt <- diffinv(Zt)
	return( x + DBt@)
}
set.seed(123)@#@V[hŒ
Time <- seq(0,@1,@by@=@1/1000)@# TvO̐ݒ@
MC <- 30 # JԂ
result <- replicate(MC,@simulateDBM(Time,@x = 4,@c = 3,@sigma = 2)) # ̃htgFjYɂ
matplot(Time,result,type="l",lty=1,col="grey", xlab="Time", ylab="Drifted BM", ylim=c(-1,10))
result2 <- replicate(MC, simulateDBM(Time,4,-3,2)) # ̃htgFjY₷
par(new=T) # }d˕`
matplot(Time, result2, ,type="l",lty=1,col="blue", xlab="Time", ylab="Drifted BM", ylim=c(-1,10))
abline(h = 0, lty = 2, lwd = 2, col = "red")
text(0.4,9,expression(c>0), cex=2, col="grey")
text(0.2,1,expression(c<0), cex=2,col="blue")



### jYm̃eJvZ
## jYm͉̉
psi <- function(t,x,c,sigma,d){
	x1 <- (x-d+c*t)/sigma/sqrt(t); x2 <- (d-x+c*t)/sigma/sqrt(t)
	return( 1 - pnorm(x1) + exp(-2*c*(x-d)/sigma^2)*pnorm(x2) )
}

MC <- 1000 # eJ@̌JԂ
##jYoV~[^
ruin.indicator <- function(Time,x,c,sigma){
	bm <- simulateDBM(Time,x,c,sigma) # DBM̃pX̐
	ind <- length(bm[bm<0]) # DBM̃pXŕl邩T
	if(ind > 0) return(1)	# jYĂiind>0jPԂ
	else return(0)
}
Time <- seq(0,1,by=1/10000) 
# ӁF by=1/1000炢ł̓pXeŃeJvZłȃoCAXo
## eJ@ɂjYm̋ߎvZ
set.seed(123) # V[hŒ
ruin.freq <- sum( replicate(MC, ruin.indicator(Time,x = 4, c = -3, sigma = 2)) ) # jYpX̐
( ruin.prob <- ruin.freq/MC) # [0,1]ł̌ojYm
( psi(1,4,-3,2,0) ) # ͉





Section 3
### htgt̕|A\ߒFxϊɂpX̕ω
##@|A\f̒`
mod.cp <- setModel(drift = "c", # htgW
                jump.coeff = -1, # Wvߒ̌W(̃Wv)
                measure.type = "CP", # WvxCP(|A\)Ɏw
                measure = list(intensity = "lambda", list(df = "dexp(z,1/mu)"))
                # Wvx: x(intensity)ƃWv̖x֐(mu̎wz)ɕĎw
)
##TvO_̒`
T <- 1 # I[_̐ݒ
samp <- setSampling(Initial = 0, # _
                    Terminal = T, # I[_
                    n = 1000*T # TvO_(_͏)
)
## vf̒`
dCP <- setYuima(model = mod.cp, # htgt|A\f
                sampling = samp # TvO_
)
x0 <- 10 #@l
c <- 15; lambda <- 5; mu <- 1# P̉ł̃p[^̐ݒ
set.seed(123) #@V[ȟŒ
plot(simulate(dCP, xinit = x0, true.parameter = list(c = c, lambda = lambda, mu = mu)), ylim = c(-10,20), col = "blue")# P̉ł̃pX
par(new=T)
set.seed(123)
plot(simulate(dCP, xinit = x0, true.parameter = list(c = c, lambda = c/mu, mu = c/lambda)), ylim = c(-10,20), col = "red")# P^*̉ł̃pX
abline(h = 0, lty = 2)


###d_TvOɂjYmvZ
x0 <- 3 #@l
c <- 60; lambda <- 3; mu <- 1 # P̉ł̃p[^̐ݒ

## P^*ɂҒlWvZV~[^
gamma <- 1/mu - lambda/c # W
ruin.coeff <- function(smod, x0, param, gamma){
	out <- simulate(dCP, xinit = x0, true.parameter = param)
	dcp <- get.zoo.data(out)[[1]] # T[vX̃f[^o
	indicator <- dcp[which(dcp<0)] #(jYǂ𔻒肷邽߂) X(t)̕lo
	if(length(indicator) >0){@#@jYĂ
		deficit <- indicator[1] #T[vXX(t)ŏɕɂȂƂ̒lX()o
		return( exp(gamma*deficit) ) # WvZ
	}
	else return(0)
}

##V~[V		
param <- list(c = c, lambda = c/mu, mu = c/lambda)  #@P^*̉ł̃p[^ݒ
MC <- 100 #@JԂ
set.seed(123)
coeff <- sum( replicate(MC, ruin.coeff(dCP, x0 = x0, param = param, gamma = gamma)) )/MC # WZo
( ruin.prob <- coeff*exp(-gamma*x0) )# eJ@ɂjYm\
[1] 0.002780525
( psi0 <- (lambda*mu/c)*exp(-gamma*x0) )#@͉\
[1] 0.002892216


### [Ql]eJɂ̎̑ώ@iP^*̉ł̃V~[Vj
set.seed(123) 
MC <- seq(100,10000,by=100)
ruin.prob <- NULL
for(i in 1:length(MC)){
	@cat(MC[i],">") # V~[Vǂ܂Ői񂾂mFCWP[^
	 coeff <- sum( replicate(MC[i], ruin.coeff(dCP, x0 = x0, param = param, gamma = gamma)) )/MC[i]
	 #P̉ŃV~[VȂCp[^ݒ̂悤ɕς΂悢F param <- list(c = c, lambda = lambda, mu = mu)
	 ruin.prob <- append(ruin.prob, coeff*exp(-gamma*x0))
}
plot(MC,(ruin.prob-psi0)/psi0,type = "l", lty = 1, xlab = "MC", ylab = "Relative Error")@#Ό덷̃vbg
abline(h=0, lty=1, col="red")



Section 4

### Gamma-OŨpXEV~[V
## Gamma-OUf̒`
mod <- setModel(drift = "-theta*x", # htgW
                jump.coeff = 1, # Wvߒ̌W
                measure.type = "CP", 
                # Wvx̎w@: Levyߒ̑𔭐闐w
                measure = list(intensity = 4, 
                               df = "dexp(z,2)"),
                # Wvx: PʋԂɑΉLevyߒ̑̏]w
)
## TvO_̒`
n <- 1000; T <- 1
samp <- setSampling(Initial = 0, # _
                    Terminal = T, # I[_
                    n = n # TvO_(_͏)
)
## vf̒`
gammaOU <- setYuima(model = mod, # mf
                    sampling = samp # TvO_
)
## V~[VƃTvpX̕`
set.seed(223)
lambda0 <- 1 # l
theta <- 1; a <- 4; b <- 2 # p[^ݒ
param <- list(theta = theta, shape = a, rate = b) # p[^[̒l
# V~[V̎s
result <- simulate(gammaOU, # vf
                   xinit = lambda0, # l
                   true.parameter = param # p[^[̒l
)
plot(result, col = "royalblue")


### Gamma-OUɂ鐶mV~[V
## m͉̉
eta <- function(t, lambda0, theta, a, b){
  exp( -lambda0*(1 - exp(-theta*t))/theta 
       - theta*a*( b*log( b/(b + (1-exp(-theta*t))/theta)) + t )/(1 + theta*b) )
}
( 
  etaT <- eta(T, lambda0, theta, a, b) 
) #m͉̉
## V~[^̍쐬
ELambda <- function(smod, lambda0, param){
  out <- simulate(gammaOU, xinit = lambda0, true.parameter = param)
  lambda <- as.numeric(get.zoo.data(out)[[1]]) #gammaOŨpX̒lo
  int.lambda <- sum(lambda[1:length(lambda)-1]/n) # lambda(t)̐ϕɑ΂郊[}a
  return(exp(-int.lambda)) 
}

## eJEV~[V
MC <- 5000
t1 <- system.time(obj <- replicate(MC, ELambda(gammaOU, lambda0, param)))
print(t1)
surv.prob <- cumsum(obj)/(1:MC)
cat("analytic ", etaT, "\n")
cat("MC ", surv.prob[MC], "\n")

plot((surv.prob-etaT)/etaT,type = "l", lty = 1, xlab = "MC", 
     ylab = "Relative Error") #Ό덷̃vbg
abline(h=0, lty=1, col="red")









